package com.biel.FastSurvival.Dimensions.Moon;

import java.util.ArrayList;
import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.Chunk;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.generator.BlockPopulator;
import org.bukkit.util.Vector;

import com.biel.FastSurvival.Utils.Cuboid;
import com.biel.FastSurvival.Utils.Utils;
import com.biel.FastSurvival.Utils.Cuboid.CuboidDirection;

public class MoonMagicTreePopulator extends BlockPopulator {
	private static final int TREE_CHANCE = 1; // Out of 100 (45)
	@Override
	public void populate(World world, Random random, Chunk source) {
		if (!(random.nextInt(100) <= TREE_CHANCE)) {return;}
		int centerX = (source.getX() << 4) + random.nextInt(16);
		int centerZ = (source.getZ() << 4) + random.nextInt(16);
		int centerY = world.getHighestBlockYAt(centerX, centerZ);
		Location center = new Location(world, centerX, centerY, centerZ);
		int radius = 2; //Utils.NombreEntre(2, 5);
		Cuboid sc = generateCenterCuboid(center, 40, radius);
		for (Block b: sc.getBlocks()){
			b.setType(Material.REDSTONE_BLOCK);
//			if (Utils.Possibilitat(1)){
//				b.setType(Material.WOOD);
//			}
		}
		generateStair(center.clone(), 40, radius + 1, 1, Utils.NombreEntre(1, 3));
		GenerateTopTree(center.add(0, 40, 0), 6, Utils.NombreEntre(14, 18));
		//generateStair(center.clone(), 40, radius + 6, 1, Utils.NombreEntre(1, 3));
	}
	public Cuboid generateCenterCuboid(Location center, int height, int width){
		Cuboid c = new Cuboid(center.clone().add(-1 * width, 0, -1 * width),center.clone().add(width, height, width));
		c.expand(CuboidDirection.Up, height - 1);
		return c;
	}
	public void generateStair(Location center, int MaxHeight, int radius, int amp, int UpFact){
		int height = 0;
		int upFactRemaining = UpFact; 
		int forwardCount = 0; //Max 4
		Location l = center.clone().add(-1 * (radius), 0, radius);
		l.setDirection(Utils.CrearVector(l, l.clone().add(0, 0, -1)));
		while (height <= MaxHeight){
			Location elevLoc = l.clone().add(0, height, 0);
			//elevLoc.getBlock().setType(Material.DIAMOND_BLOCK);
			//Laterals
			Vector vOut = new Vector(l.getDirection().getZ(), l.getDirection().getY(), -1 * l.getDirection().getX());
			int RemAmp = amp;
			while (RemAmp >= 0){
				Location lBlock = elevLoc.clone().add(vOut.clone().multiply(RemAmp));
				if (!Utils.Possibilitat(1)){
					lBlock.getBlock().setType(Material.REDSTONE_BLOCK);
				}
				RemAmp--;
			}
			//----
			if (forwardCount >= radius * 2){
				forwardCount = 0;
				l.setDirection(new Vector(-1 * l.getDirection().getZ(), l.getDirection().getY(), l.getDirection().getX()));
			}else{
				l = l.clone().add(l.getDirection());
				forwardCount++;
				if (upFactRemaining <= 0){
					upFactRemaining = UpFact;
					height++;
				}else{
					upFactRemaining--;
				}
			}
			
			
		}
	}
	public void GenerateTopTree(Location center, int height, int radius){
		ArrayList<Block> blks = new ArrayList<Block>();
		blks.addAll(Utils.getCylBlocks(center.clone().add(0, height, 0), radius -1, 1, true));
		blks.addAll(Utils.getOuterCylBlocks(center.clone().add(0, 2, 0), radius, height, false));
		blks.addAll(Utils.getCylBlocks(center.clone(), radius -1, 2, true));
		for(Block b : blks){
			b.setType(Material.LAPIS_BLOCK);
		}
	}

}
