package com.biel.FastSurvival.Recall;

import java.util.ArrayList;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.inventory.meta.ItemMeta;

import com.biel.FastSurvival.Bows.BowUtils.BowType;
import com.biel.FastSurvival.Utils.Utils;

public class RecallUtils {
	
	public void addRecallRecipe(){
		ShapedRecipe r = new ShapedRecipe(getRecallItem(null));
		r.shape(" D ", "VBV", "RLR");
		r.setIngredient('B', Material.BOW);
		r.setIngredient(
'V', Material.IRON_BARDING);
		r.setIngredient('D', Material.DIAMOND);
		r.setIngredient('L', Material.DIAMOND_BLOCK);
		Bukkit.getServer().addRecipe(r);
		
	}
	//Exemple - Material.WATCH
			/* Recall - Linked
			 * X: 605, Y: 72, Z: 562
			 * PiloWorld
			 * Cast: 5s, Idle: 12s
			 */
			/* Recall - Unlinked
			 * Right click to link
			 */
	public ItemStack getRecallItem(RecallLink link){
		ItemStack itemStack = new ItemStack(Material.WATCH);
		String name = "Recall" + " - ";
		String line2 = ChatColor.YELLOW + "";
		String line3 = ChatColor.YELLOW + "";
		String line4 = ChatColor.WHITE + "";
		if (link == null){
			name = name + ChatColor.RED + "Unlinked";
			line2 = line2 + "Right click to link";
			line3 = line3 + "No material info";

			return Utils.setItemNameAndLore(itemStack, name, line2, line3, line4);
		}else{
			name = name + ChatColor.GREEN + "Linked";
			Location l = link.getLinkLocation();
			line2 = line2 + Utils.writeHumanReadableLocation(l, false);
			ArrayList<String> c = new ArrayList<String>();
			ArrayList<String> v = new ArrayList<String>();
			c.add("Cast");v.add(Integer.toString(link.getCastTime()));
			c.add("Idle");v.add(Integer.toString(link.getIdleTime()));
			line3 = line3 + l.getWorld().getName();
			line4 = line4 + Utils.writeHumanReadableList(c, v);

			return Utils.setItemNameAndLore(itemStack, name, line2, line3, line4);
		}
		
	}
	public static RecallLink getRecallLink(Player p, ItemStack stack){
		if (stack.getType() != Material.WATCH || !stack.hasItemMeta()){
			return null;
		}
		//Extract
		ItemMeta meta = stack.getItemMeta();
		if (!meta.hasDisplayName() || !meta.hasLore()){return null;}
		String name = meta.getDisplayName();
		String line2 = meta.getLore().get(0);
		String line3 = meta.getLore().get(1);
		String line4 = meta.getLore().get(2);
		//Parse
		RecallLink link = new RecallLink();
		World world = Bukkit.getWorld(line3);
		link.setLinkLocation(Utils.readHumanReadableLocation(line2, world));
		int cast, idle;
		ArrayList<String> l4parts = Utils.readHumanReadableList(line4);
		cast = Integer.parseInt(l4parts.get(0));
		idle = Integer.parseInt(l4parts.get(1));
		link.setCastTime(cast);
		link.setIdleTime(idle);
		//Return
		return link;
		
	}
	//X: 605, Y: 72, Z: 562 
	Location locationFromMiddle(World w, String text){
		int lastIndex = 0;
		ArrayList<String> parts = new ArrayList<String>();
		while(parts.size() < 3){
             System.out.println(lastIndex);
             if (lastIndex > text.length()){
                 lastIndex = text.length() - 1;
             }
             if (lastIndex < 0){
                 lastIndex = 0;
             }
			int beginIndex = text.indexOf(":", lastIndex) + 2;
			int endIndex =  text.indexOf(",", beginIndex);
            if (endIndex == -1){
                 endIndex = text.length();
             }
            System.out.println("Begin: " + beginIndex);
            System.out.println("End: " + endIndex);
            
			parts.add(text.substring(beginIndex, endIndex));
            lastIndex = endIndex;
		}
		//Return a location
		int x, y, z;
		x = Integer.parseInt(parts.get(0));
		y = Integer.parseInt(parts.get(1));
		z = Integer.parseInt(parts.get(2));
		Location loc = new Location(w, x, y, z);
		return loc;
	}
	public static void playerLinkItemInHand(Player p, Location l){
		//Link - Replace item in hand
		RecallLink current = getRecallLink(p, p.getItemInHand());
		
	}
}
